/***
 * Juliac
 * Copyright (C) 2007-2012 Inria, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.juliac;

import java.util.List;

import org.apache.maven.artifact.Artifact;
import org.apache.maven.artifact.metadata.ArtifactMetadataRetrievalException;
import org.apache.maven.artifact.resolver.ArtifactNotFoundException;
import org.apache.maven.artifact.resolver.ArtifactResolutionException;

/**
 * Interface for accessing {@link AbstractJuliacMojo}. This interface is used as a
 * callback interface by {@link JuliacMojoClassPathElements}.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @since 2.1
 */
public interface JuliacMojoItf {

    public String getPluginVersion() throws IllegalArgumentException;
    
    public Artifact resolveArtifact(
        String groupId, String artifactId, String version, String type,
        String classifier )
    throws ArtifactResolutionException, ArtifactNotFoundException;

    public void resolveArtifact( Artifact artifact )
    throws ArtifactResolutionException, ArtifactNotFoundException;

    public List<Artifact> resolveArtifactTransitively( List<Artifact> artifacts )
    throws
        ArtifactResolutionException, ArtifactMetadataRetrievalException,
        ArtifactNotFoundException;
}
