/***
 * Juliac
 * Copyright (C) 2011-2012 Inria, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.juliac;


/**
 * This class implements the configuration parameters for the <proxy> tag of the
 * Juliac MOJO. The <proxy> tag specifies the interface signature and the
 * controller descriptor whose code is to be generated by Juliac.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @since 2.3.1
 */
public class Proxy {

    /**
     * The interface signature.
     * 
     * @parameter
     */
    private String signature;
    
    /**
     * The controller descriptor.
     * 
     * @parameter
     */
    private String controllerDesc;
    
    
    // ---------------------------------------------------------------------
    // Getters
    // ---------------------------------------------------------------------

    public String getSignature() {
        return Utils.trimHeadingAndTrailingBlanks(signature);
    }
    
    public String getControllerDesc() {
        return Utils.trimHeadingAndTrailingBlanks(controllerDesc);
    }
    
    @Override
    public String toString() {
        return signature+':'+controllerDesc;
    }
}
